/* 
 * File:   Timer.cpp
 * Author: dny
 * 
 * Created on November 9, 2009, 3:47 PM
 */

#include <stdio.h>
#include <sys/time.h>

#include "Timer.h"

Timer::Timer() {
}

Timer::~Timer() {
}

void Timer::startTimer() {

    startTimer(MAX_TIME);

}

void Timer::startTimer(long int limit) {

    struct itimerval time;

    if(limit > MAX_TIME) {

        limit = MAX_TIME;

    }

    time.it_value.tv_sec = time.it_interval.tv_sec = limit;

    time.it_value.tv_usec = time.it_interval.tv_usec = 0l;

    if (setitimer(ITIMER_PROF, &time, 0)) {
        
        fprintf(stderr, "Could not set the timer!\n");

    }

}

double Timer::getElapsedTime() {

    struct itimerval time;

    if(getitimer(ITIMER_PROF, &time)) {

        fprintf(stderr, "Could not read the timer!\n");

        return -1.0;

    }

    double seconds = time.it_interval.tv_sec - time.it_value.tv_sec;

    double useconds = time.it_interval.tv_usec - time.it_value.tv_usec;

    return seconds + useconds / 1e6;

}